#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    lli n;
    cin >> n;
    vector<lli> a(n);
    vector<pair<lli, lli> > ans;
    for(lli i = 0, x; i < n; i++) cin >> x, a[i] = --x;
//    for(auto& x : a) cout << x << " ";
//    cout << endl;
    for(lli i = 0; i < n; i++)
    {
        if(a[i] != i)
        {
            for(lli j = i+1; j < n; j++)
            {
                if(a[j] == i)
                {
                    ans.emplace_back(i+1, j+1);
                    for(lli ii = i, c = 0; ii <= j/2; ii++, c++) swap(a[ii], a[j-c]);
                }
            }
        }
//        for(auto& x : a) cout << x << " ";
//        cout << endl;
    }
    cout << ans.size() << endl;
    for(auto& x : ans) cout << x.first << " " << x.second << endl;
}
